ISORT(1)

NAME
isort - sort Python import definitions

DESCRIPTION
usage: isort [-h] [-V] [--vn] [-v] [--only-modified] [--dedup-headings] [-q]

    [-d] [--overwrite-in-place] [--show-config] [--show-files] [--df] [-c] [--ws] [--sp SETTINGS_PATH] [--cr CONFIG_ROOT] [--resolve-all-configs] [--profile PROFILE] [--old-finders] [-j [JOBS]] [--ac] [--interactive] [--format-error FORMAT_ERROR] [--format-success FORMAT_SUCCESS] [--srx] [--filter-files] [-s SKIP] [--extend-skip EXTEND_SKIP] [--sg SKIP_GLOB] [--extend-skip-glob EXTEND_SKIP_GLOB] [--gitignore] [--ext SUPPORTED_EXTENSIONS] [--blocked-extension BLOCKED_EXTENSIONS] [--dont-follow-links] [--filename FILENAME] [--allow-root] [-a ADD_IMPORTS] [--append] [--af] [--rm REMOVE_IMPORTS] [--float-to-top] [--dont-float-to-top] [--ca] [--cs] [-e] [--ff] [--fgw [FORCE_GRID_WRAP]] [-i INDENT] [--lbi LINES_BEFORE_IMPORTS] [--lai LINES_AFTER_IMPORTS] [--lbt LINES_BETWEEN_TYPES] [--le LINE_ENDING] [--ls] [--lss] [-m {GRID,VERTICAL,HANGING_INDENT,VERTICAL_HANGING_INDENT,VERTICAL_GRID,VERTICAL_GRID_GROUPED,VERTICAL_GRID_GROUPED_NO_COMMA,NOQA,VERTICAL_HANGING_INDENT_BRACKET,VERTICAL_PREFIX_FROM_MODULE_IMPORT,HANGING_INDENT_WITH_PARENTHESES,BACKSLASH_GRID,0,1,2,3,4,5,6,7,8,9,10,11}] [-n] [--nis] [--ot] [--dt] [--rr] [--reverse-sort] [--sort-order SORT_ORDER] [--sl] [--nsl SINGLE_LINE_EXCLUSIONS] [--tc] [--up] [-l LINE_LENGTH] [--wl WRAP_LENGTH] [--case-sensitive] [--remove-redundant-aliases] [--honor-noqa] [--treat-comment-as-code TREAT_COMMENTS_AS_CODE] [--treat-all-comment-as-code] [--formatter FORMATTER] [--color] [--ext-format EXT_FORMAT] [--star-first] [--split-on-trailing-comma] [--sd DEFAULT_SECTION] [--only-sections] [--ds] [--fas] [--fss] [--hcss] [--srss] [--fass] [-t FORCE_TO_TOP] [--combine-straight-imports] [--nlb NO_LINES_BEFORE] [--src SRC_PATHS] [-b KNOWN_STANDARD_LIBRARY] [--extra-builtin EXTRA_STANDARD_LIBRARY] [-f KNOWN_FUTURE_LIBRARY] [-o KNOWN_THIRD_PARTY] [-p KNOWN_FIRST_PARTY] [--known-local-folder KNOWN_LOCAL_FOLDER] [--virtual-env VIRTUAL_ENV] [--conda-env CONDA_ENV] [--py {all,2,27,3,310,311,312,313,36,37,38,39,auto}] [files ...]

Sort Python import definitions alphabetically within logical sections. Run with no arguments to see a quick start guide, otherwise, one or more files/directories/stdin must be provided. Use `-` as the first argument to represent stdin. Use --interactive to use the pre 5.0.0 interactive behavior. If you've used isort 4 but are new to isort 5, see the upgrading guide: https://pycqa.github.io/isort/docs/upgrade_guides/5.0.0.html

  general options:

-h, --help
    show this help message and exit

-V, --version
    Displays the currently installed version of isort.

--vn, --version-number
    Returns just the current version number without the logo

-v, --verbose
    Shows verbose output, such as when files are skipped or when a check is successful.

--only-modified, --om
    Suppresses verbose output for non-modified files.

--dedup-headings
    Tells isort to only show an identical custom import heading comment once, even if there are multiple sections with the comment set.

-q, --quiet
    Shows extra quiet output, only errors are outputted.

-d, --stdout
    Force resulting output to stdout, instead of in-place.

--overwrite-in-place
    Tells isort to overwrite in place using the same file handle. Comes at a performance and memory usage penalty over its standard approach but ensures all file flags and modes stay unchanged.

--show-config
    See isort's determined config, as well as sources of config options.

--show-files
    See the files isort will be run against with the current config options.

--df, --diff
    Prints a diff of all the changes isort would make to a file, instead of changing it in place

-c, --check-only, --check
    Checks the file for unsorted / unformatted imports and prints them to the command line without modifying the file. Returns 0 when nothing would change and returns 1 when the file would be reformatted.

--ws, --ignore-whitespace
    Tells isort to ignore whitespace differences when --check-only is being used.

--sp, --settings-path, --settings-file, --settings SETTINGS_PATH
    Explicitly set the settings path or file instead of auto determining based on file location.

--cr, --config-root CONFIG_ROOT
    Explicitly set the config root for resolving all configs. When used with the --resolve-all-configs flag, isort will look at all sub-folders in this config root to resolve config files and sort files based on the closest available config(if any)

--resolve-all-configs
    Tells isort to resolve the configs for all subdirectories and sort files in terms of its closest config files.

--profile PROFILE
    Base profile type to use for configuration. Profiles include: black, django, pycharm, google, open_stack, plone, attrs, hug, wemake, appnexus. As well as any shared profiles.

--old-finders, --magic-placement
    Use the old deprecated finder logic that relies on environment introspection magic.

-j, --jobs [JOBS]
    Number of files to process in parallel. Negative value means use number of CPUs.

--ac, --atomic
    Ensures the output doesn't save if the resulting file contains syntax errors.

--interactive
    Tells isort to apply changes interactively.

--format-error FORMAT_ERROR
    Override the format used to print errors.

--format-success FORMAT_SUCCESS
    Override the format used to print success.

--srx, --sort-reexports
    Automatically sort all re-exports (module level __all__ collections)

  target options:

files
    One or more Python source files that need their imports sorted.

--filter-files
    Tells isort to filter files even when they are explicitly passed in as part of the CLI command.

-s, --skip SKIP
    Files that isort should skip over. If you want to skip multiple files you should specify twice: --skip file1 --skip file2. Values can be file names, directory names or file paths. To skip all files in a nested path use --skip-glob.

--extend-skip EXTEND_SKIP
    Extends --skip to add additional files that isort should skip over. If you want to skip multiple files you should specify twice: --skip file1 --skip file2. Values can be file names, directory names or file paths. To skip all files in a nested path use --skipglob.

--sg, --skip-glob SKIP_GLOB
    Files that isort should skip over.

--extend-skip-glob EXTEND_SKIP_GLOB
    Additional files that isort should skip over (extending --skip-glob).

--gitignore, --skip-gitignore
    Treat project as a git repository and ignore files listed in .gitignore. NOTE: This requires git to be installed and accessible from the same shell as isort.

--ext, --extension, --supported-extension SUPPORTED_EXTENSIONS
    Specifies what extensions isort can be run against.

--blocked-extension BLOCKED_EXTENSIONS
    Specifies what extensions isort can never be run against.

--dont-follow-links
    Tells isort not to follow symlinks that are encountered when running recursively.

--filename FILENAME
    Provide the filename associated with a stream.

--allow-root
    Tells isort not to treat / specially, allowing it to be run against the root dir.

  general output options:

-a, --add-import ADD_IMPORTS
    Adds the specified import line to all files, automatically determining correct placement.

--append, --append-only
    Only adds the imports specified in --add-import if the file contains existing imports.

--af, --force-adds
    Forces import adds even if the original file is empty.

--rm, --remove-import REMOVE_IMPORTS
    Removes the specified import from all files.

--float-to-top
    Causes all non-indented imports to float to the top of the file having its imports sorted (immediately below the top of file comment). This can be an excellent shortcut for collecting imports every once in a while when you place them in the middle of a file to avoid context switching. *NOTE*: It currently doesn't work with cimports and introduces some extra over-head and a performance penalty.

--dont-float-to-top
    Forces --float-to-top setting off. See --float-to-top for more information.

--ca, --combine-as
    Combines as imports on the same line.

--cs, --combine-star
    Ensures that if a star import is present, nothing else is imported from that namespace.

-e, --balanced
    Balances wrapping to produce the most consistent line length possible

--ff, --from-first
    Switches the typical ordering preference, showing from imports first then straight ones.

--fgw, --force-grid-wrap [FORCE_GRID_WRAP]
    Force number of from imports (defaults to 2 when passed as CLI flag without value) to be grid wrapped regardless of line length. If 0 is passed in (the global default) only line length is considered.

-i, --indent INDENT
    String to place for indents defaults to " " (4 spaces).

--lbi, --lines-before-imports LINES_BEFORE_IMPORTS

--lai, --lines-after-imports LINES_AFTER_IMPORTS

--lbt, --lines-between-types LINES_BETWEEN_TYPES

--le, --line-ending LINE_ENDING
    Forces line endings to the specified value. If not set, values will be guessed per-file.

--ls, --length-sort
    Sort imports by their string length.

--lss, --length-sort-straight
    Sort straight imports by their string length. Similar to `length_sort` but applies only to straight imports and doesn't affect from imports.

-m, --multi-line {GRID,VERTICAL,HANGING_INDENT,VERTICAL_HANGING_INDENT,VERTICAL_GRID,VERTICAL_GRID_GROUPED,VERTICAL_GRID_GROUPED_NO_COMMA,NOQA,VERTICAL_HANGING_INDENT_BRACKET,VERTICAL_PREFIX_FROM_MODULE_IMPORT,HANGING_INDENT_WITH_PARENTHESES,BACKSLASH_GRID,0,1,2,3,4,5,6,7,8,9,10,11}
    Multi line output (0-grid, 1-vertical, 2-hanging, 3-vert-hanging, 4-vert-grid, 5-vert-grid-grouped, 6-deprecated-alias-for-5, 7-noqa, 8-vertical-hangingindent-bracket, 9-vertical-prefix-from-module-import, 10-hanging-indent-with-parentheses).

-n, --ensure-newline-before-comments
    Inserts a blank line before a comment following an import.

--nis, --no-inline-sort
    Leaves `from` imports with multiple imports 'as-is' (e.g. `from foo import a, c ,b`).

--ot, --order-by-type
    Order imports by type, which is determined by case, in addition to alphabetically. **NOTE**: type here refers to the implied type from the import name capitalization. isort does not do type introspection for the imports. These "types" are simply: CONSTANT_VARIABLE, CamelCaseClass, variable_or_function. If your project follows PEP8 or a related coding standard and has many imports this is a good default, otherwise you likely will want to turn it off. From the CLI the `--dont-order-by-type` option will turn this off.

--dt, --dont-order-by-type
    Don't order imports by type, which is determined by case, in addition to alphabetically. **NOTE**: type here refers to the implied type from the import name capitalization. isort does not do type introspection for the imports. These "types" are simply: CONSTANT_VARIABLE, CamelCaseClass, variable_or_function. If your project follows PEP8 or a related coding standard and has many imports this is a good default. You can turn this on from the CLI using `--order-by-type`.

--rr, --reverse-relative
    Reverse order of relative imports.

--reverse-sort
    Reverses the ordering of imports.

--sort-order SORT_ORDER
    Specify sorting function. Can be built in (natural[default] = force numbers to be sequential, native = Python's built-in sorted function) or an installable plugin.

--sl, --force-single-line-imports
    Forces all from imports to appear on their own line

--nsl, --single-line-exclusions SINGLE_LINE_EXCLUSIONS
    One or more modules to exclude from the single line rule.

--tc, --trailing-comma
    Includes a trailing comma on multi line imports that include parentheses.

--up, --use-parentheses
    Use parentheses for line continuation on length limit instead of slashes. **NOTE**: This is separate from wrap modes, and only affects how individual lines that are too long get continued, not sections of multiple imports.

-l, -w, --line-length, --line-width LINE_LENGTH
    The max length of an import line (used for wrapping long imports).

--wl, --wrap-length WRAP_LENGTH
    Specifies how long lines that are wrapped should be, if not set line_length is used. NOTE: wrap_length must be LOWER than or equal to line_length.

--case-sensitive
    Tells isort to include casing when sorting module names

--remove-redundant-aliases
    Tells isort to remove redundant aliases from imports, such as `import os as os`. This defaults to `False` simply because some projects use these seemingly useless aliases to signify intent and change behaviour.

--honor-noqa
    Tells isort to honor noqa comments to enforce skipping those comments.

--treat-comment-as-code TREAT_COMMENTS_AS_CODE
    Tells isort to treat the specified single line comment(s) as if they are code.

--treat-all-comment-as-code
    Tells isort to treat all single line comments as if they are code.

--formatter FORMATTER
    Specifies the name of a formatting plugin to use when producing output.

--color
    Tells isort to use color in terminal output.

--ext-format EXT_FORMAT
    Tells isort to format the given files according to an extensions formatting rules.

--star-first
    Forces star imports above others to avoid overriding directly imported variables.

--split-on-trailing-comma
    Split imports list followed by a trailing comma into VERTICAL_HANGING_INDENT mode

  section output options:

--sd, --section-default DEFAULT_SECTION
    Sets the default section for import options: ('FUTURE', 'STDLIB', 'THIRDPARTY', 'FIRSTPARTY', 'LOCALFOLDER')

--only-sections, --os
    Causes imports to be sorted based on their sections like STDLIB, THIRDPARTY, etc. Within sections, the imports are ordered by their import style and the imports with the same style maintain their relative positions.

--ds, --no-sections
    Put all imports into the same section bucket

--fas, --force-alphabetical-sort
    Force all imports to be sorted as a single section

--fss, --force-sort-within-sections
    Don't sort straight-style imports (like import sys) before from-style imports (like from itertools import groupby). Instead, sort the imports by module, independent of import style.

--hcss, --honor-case-in-force-sorted-sections
    Honor `--case-sensitive` when `--force-sort-withinsections` is being used. Without this option set, `--order-by-type` decides module name ordering too.

--srss, --sort-relative-in-force-sorted-sections
    When using `--force-sort-within-sections`, sort relative imports the same way as they are sorted when not using that setting.

--fass, --force-alphabetical-sort-within-sections
    Force all imports to be sorted alphabetically within a section

-t, --top FORCE_TO_TOP
    Force specific imports to the top of their appropriate section.

--combine-straight-imports, --csi
    Combines all the bare straight imports of the same section in a single line. Won't work with sections which have 'as' imports

--nlb, --no-lines-before NO_LINES_BEFORE
    Sections which should not be split with previous by empty lines

--src, --src-path SRC_PATHS
    Add an explicitly defined source path (modules within src paths have their imports automatically categorized as first_party). Glob expansion (`*` and `**`) is supported for this option.

-b, --builtin KNOWN_STANDARD_LIBRARY
    Force isort to recognize a module as part of Python's standard library.

--extra-builtin EXTRA_STANDARD_LIBRARY
    Extra modules to be included in the list of ones in Python's standard library.

-f, --future KNOWN_FUTURE_LIBRARY
    Force isort to recognize a module as part of Python's internal future compatibility libraries. WARNING: this overrides the behavior of __future__ handling and therefore can result in code that can't execute. If you're looking to add dependencies such as six, a better option is to create another section below --future using custom sections. See: https://github.com/PyCQA/isort#custom-sections-andordering and the discussion here: https://github.com/PyCQA/isort/issues/1463.

-o, --thirdparty KNOWN_THIRD_PARTY
    Force isort to recognize a module as being part of a third party library.

-p, --project KNOWN_FIRST_PARTY
    Force isort to recognize a module as being part of the current python project.

--known-local-folder KNOWN_LOCAL_FOLDER
    Force isort to recognize a module as being a local folder. Generally, this is reserved for relative imports (from . import module).

--virtual-env VIRTUAL_ENV
    Virtual environment to use for determining whether a package is third-party

--conda-env CONDA_ENV
    Conda environment to use for determining whether a package is third-party

--py, --python-version {all,2,27,3,310,311,312,313,36,37,38,39,auto}
    Tells isort to set the known standard library based on the specified Python version. Default is to assume any Python 3 version could be the target, and use a union of all stdlib modules across versions. If auto is specified, the version of the interpreter used to run isort (currently: 313) will be used.

_   _

(_) ___
    ___ _ __| |_

| |/ _/ / _ \/ '__
    _/

| |\__ \/\_\/| |
    | |_

|_|\___/\___/\_/
    \_/

    isort your imports, so you don't have to.

    VERSION 6.0.0

SEE ALSO
Additional documentation for isort is available online at

https://pycqa.github.io/isort/